/*   AŃQ[  ""  Ver 0.00   */
/*                                      */
/*                                      */
/*   by Atsushi                98/4/1   */


package counter;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.MalformedURLException;
import java.net.URL;
import lib.awt.LightweightPanel;
import lib.awt.Paper;
import game.awt.ImageBox;
import game.awt.SoundBox;
import game.ranking.Ranking;


public class Counter extends Applet implements ActionListener
{
	/*   ---   萔   ---   */

	private final static String DEFAULT_NAME="OĂ";

	/*   ---   Field   ---   */

	private CounterScreen counter;
	private TimerScreen timer;
	private RankingScreen rank;

	private Paper message1,message2;
	private Paper message3,message4;

	private CardLayout layout;
	private LightweightPanel panel;

	private TextField name;
	private Button reset;

	private ImageBox imageBox;
	private SoundBox soundBox;
	private MessageManager message;
	private Ranking ranking;

	/*   ---      ---   */

	public void init()
	{
		ClickInformant informant;
		URL address;
	
		try {
			address=new URL(getCodeBase());
			ranking=new Ranking(address);
		} catch (MalformedURLException e) {System.out.println(e);}
		
		initImage();
		initSound();
		
		message1=new Paper();message2=new Paper();
		message3=new Paper();message4=new Paper();
		message=new MessageManager(
		            message1,message2,message3,message4,imageBox);
		
		counter=new CounterScreen(this,imageBox,soundBox);
		timer  =new TimerScreen(this,imageBox,message);
		rank   =new RankingScreen(this,imageBox,ranking);
		
		name=new TextField(DEFAULT_NAME);
		name.addActionListener(this);
		reset=new Button("Ȃ");
		reset.addActionListener(this);
		
		informant=new ClickInformant(counter);
		counter .addMouseListener(informant);
		timer   .addMouseListener(informant);
		rank    .addMouseListener(informant);
		message1.addMouseListener(informant);
		message2.addMouseListener(informant);
		message3.addMouseListener(informant);
		message4.addMouseListener(informant);
		
		initLayout();
	}

	private void initImage()
	{
		imageBox=new ImageBox(this);
		
		imageBox.load("digit" ,"counter/image/digit.gif");
		imageBox.load("crazy" ,"counter/image/crazy.gif");
		imageBox.load("end1"  ,"counter/image/end1.gif");
		imageBox.load("end2"  ,"counter/image/end2.gif");
		imageBox.load("fight1","counter/image/fight1.gif");
		imageBox.load("fight2","counter/image/fight2.gif");
		imageBox.load("go"    ,"counter/image/go.gif");
		imageBox.load("guts"  ,"counter/image/guts.gif");
		imageBox.load("huu"   ,"counter/image/huu.gif");
		imageBox.load("osii"  ,"counter/image/osii.gif");
		imageBox.load("rank"  ,"counter/image/rank.gif");
		imageBox.load("ready" ,"counter/image/ready.gif");
		imageBox.load("rest"  ,"counter/image/rest.gif");
		imageBox.load("second","counter/image/second.gif");
		imageBox.load("start" ,"counter/image/start.gif");
		imageBox.load("yahho" ,"counter/image/yahho.gif");
		imageBox.load("mark"  ,"counter/image/mark.gif");
		imageBox.load("hit"   ,"counter/image/hit.gif");
		imageBox.load("hithit","counter/image/hithit.gif");
		imageBox.load("mada"  ,"counter/image/mada.gif");
		imageBox.load("ora"   ,"counter/image/ora.gif");
		imageBox.load("name1" ,"counter/image/name1.gif");
		imageBox.load("name2" ,"counter/image/name2.gif");
	}

	private void initSound()
	{
		String param;
	
		soundBox=new SoundBox(this);
		if ((param=getParameter("mute"))!=null)
		{
			soundBox.setMute(param.equalsIgnoreCase("true") ||
			                 param.equalsIgnoreCase("yes") ||
			                 param.equalsIgnoreCase("on"));
		}
		
		soundBox.load("ready","counter/sound/ready.au");
		soundBox.load("pi"   ,"counter/sound/pi.au");
		soundBox.load("paf"  ,"counter/sound/paf.au");
		soundBox.load("start","counter/sound/start.au");
	}

	private void initLayout()
	{
		GridBagConstraints gbc;
	
		panel=new LightweightPanel(layout=new CardLayout());
		panel.add(timer,"timer");
		panel.add(rank ,"ranking");
		
		setBackground(Color.white);
		setLayout(new GridBagLayout());
		
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.HORIZONTAL;
		gbc.gridwidth =GridBagConstraints.REMAINDER;
		gbc.weightx   =1.0;
		add(name,gbc);
		
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.BOTH;
		gbc.weightx   =0.1;
		gbc.weighty   =0.5;
		add(message1,gbc);
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.BOTH;
		gbc.weightx   =0.8;
		gbc.weighty   =0.5;
		add(counter,gbc);
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.BOTH;
		gbc.gridwidth =GridBagConstraints.REMAINDER;
		gbc.weightx   =0.1;
		gbc.weighty   =0.5;
		add(message2,gbc);
		
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.BOTH;
		gbc.weightx   =0.1;
		gbc.weighty   =0.5;
		add(message3,gbc);
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.BOTH;
		gbc.weightx   =0.8;
		gbc.weighty   =0.5;
		add(panel,gbc);
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.BOTH;
		gbc.gridwidth =GridBagConstraints.REMAINDER;
		gbc.weightx   =0.1;
		gbc.weighty   =0.5;
		add(message4,gbc);
		
		gbc=new GridBagConstraints();
		gbc.fill      =GridBagConstraints.HORIZONTAL;
		gbc.gridwidth =GridBagConstraints.REMAINDER;
		gbc.weightx   =1.0;
		add(reset,gbc);
	}

	/*   ---   Applet ̓   ---   */

	public void start()
	{
		if (name.getText().equals(DEFAULT_NAME))
		{
			counter.setEnabled(false);
			message.drawInputName();
		}
		else
		{
			counter.setEnabled(true);
			message.drawReady();
			soundBox.play("ready");
		}
		counter.reset();
		layout.show(panel,"timer");
		timer.reset();
		ranking.startConnection();
	}

	public void stop()
	{
		ranking.stopConnection();
		timer.stopTimer();
	}

	/*   ---   Q[   ---   */

	public void startGame()
	{
		timer.reset();
		timer.startTimer();
		message.drawStart();
		soundBox.play("start");
	}

	public void stopGame()
	{
		counter.setEnabled(false);
		layout.show(panel,"ranking");
		rank.setScore(counter.getCount(),name.getText());
		message.drawEnd(rank.getRank());
		soundBox.play("paf");
	}

	public void reset()
	{
		timer.stopTimer();
		timer.reset();
		if (name.getText().equals(DEFAULT_NAME))
		{
			counter.setEnabled(false);
			message.drawInputName();
		}
		else
		{
			counter.setEnabled(true);
			message.drawReady();
			soundBox.play("ready");
		}
		counter.reset();
		layout.show(panel,"timer");
	}

	/*   ---   Cxg   ---   */

	public void actionPerformed(ActionEvent event)
	{
		if (event.getSource()==name)
		{
			reset();
		}
		else if (event.getSource()==reset)
		{
			reset();
		}
	}

	/*   ---   `揈   ---   */

	public void update(Graphics g)
	{
		paint(g);
	}

	/*   ---   I   ---   */

	public void destroy()
	{
		removeAll();
	}
}
