/*   AŃQ[  ""  Ver 0.00   */
/*                                      */
/*                                      */
/*   by Atsushi                98/4/1   */


package counter;

import java.awt.*;
import game.awt.DigitPainter;
import game.awt.ImageBox;
import game.awt.Screen;
import game.awt.SoundBox;
import game.awt.event.OffscreenEvent;
import game.awt.event.OffscreenListener;


class CounterScreen extends Screen implements OffscreenListener
{
	/*   ---   Field   ---   */

	private Counter applet,main;
	private ImageBox imageBox;
	private SoundBox soundBox;

	private DigitPainter digit;

	private int count;
	private boolean enabled;

	/*   ---   Constructor   ---   */

	public CounterScreen(Counter applet,ImageBox imageBox,SoundBox soundBox)
	{
		this.applet  =applet;
		this.main    =applet;
		this.imageBox=imageBox;
		this.soundBox=soundBox;
		
		addOffscreenListener(this);
		
		enabled=true;
		
		reset();
	}

	/*   ---      ---   */

	public void reset()
	{
		count=0;
		
		if (digit!=null) drawCount();
	}

	public void offscreenChanged(OffscreenEvent event)
	{
		digit=new DigitPainter(getOffscreenGraphics());
		digit.setFont(imageBox.getImage("digit"),this);
		digit.setWidth(3);
		digit.setAlignment(DigitPainter.CENTER,DigitPainter.CENTER);
		
		drawCount();
	}

	/*   ---   JEgAbv   ---   */

	public void count()
	{
		if (enabled)
		{
			soundBox.play("pi");
			
			count++;
			if (count==1) main.startGame();
			
			drawCount();
		}
	}

	public int getCount()
	{
		return count;
	}

	/*   ---   JEg   ---   */

	public boolean isEnabled()
	{
		return enabled;
	}

	public void setEnabled(boolean state)
	{
		enabled=state;
	}

	/*   ---   `揈   ---   */

	public void drawCount()
	{
		Dimension size;
	
		size=getSize();
		
		digit.drawDigit(count,size.width/2,size.height/2);
		repaint();
	}
}
