/*   AŃQ[  ""  Ver 0.00   */
/*                                      */
/*                                      */
/*   by Atsushi                98/4/1   */


package counter;

import java.awt.*;
import game.awt.DigitPainter;
import game.awt.ImageBox;
import game.awt.Screen;
import game.awt.event.OffscreenEvent;
import game.awt.event.OffscreenListener;
import game.ranking.Ranking;


class RankingScreen extends Screen implements OffscreenListener
{
	/*   ---   Field   ---   */

	private Counter applet,main;
	private ImageBox imageBox;
	private Ranking ranking;

	private DigitPainter digit;

	private int rank;

	/*   ---   Constructor   ---   */

	public RankingScreen(Counter applet,ImageBox imageBox,Ranking ranking)
	{
		this.applet  =applet;
		this.main    =applet;
		this.imageBox=imageBox;
		this.ranking =ranking;
		
		addOffscreenListener(this);
	}

	/*   ---      ---   */

	public void setScore(int score,String name)
	{
		if (ranking.isError())
		{
			rank=0;
			applet.showStatus(ranking.getErrorMessage());
		}
		else if (ranking.isConnecting())
		{
			rank=0;
			applet.showStatus("Now connecting ...");
		}
		else
		{
			rank=ranking.getRank(score);
			ranking.put(score,name);
		}
		
		if (digit!=null) drawRank();
	}

	public void offscreenChanged(OffscreenEvent event)
	{
		digit=new DigitPainter(getOffscreenGraphics());
		digit.setFont(imageBox.getImage("digit"),this);
		digit.setWidth(3);
		digit.setAlignment(DigitPainter.CENTER,DigitPainter.CENTER);
		
		drawRank();
	}

	/*   ---      ---   */

	public int getRank()
	{
		return rank;
	}

	/*   ---   `揈   ---   */

	public void drawRank()
	{
		Dimension size;
	
		size=getSize();
		
		digit.drawDigit(rank,size.width/2,size.height/2);
		repaint();
	}
}
