/*   AŃQ[  ""  Ver 0.00   */
/*                                      */
/*                                      */
/*   by Atsushi                98/4/1   */


package counter;

import java.awt.*;
import java.util.Random;
import game.awt.DigitPainter;
import game.awt.ImageBox;
import game.awt.Screen;
import game.awt.event.OffscreenEvent;
import game.awt.event.OffscreenListener;


class TimerScreen extends Screen implements OffscreenListener,Runnable
{
	/*   ---   Field   ---   */

	private static Random random=new Random();

	private Counter applet,main;
	private MessageManager message;
	private ImageBox imageBox;

	private Thread mainLoop;
	private boolean stop;

	private DigitPainter digit;

	private int time,unit;

	/*   ---   Constructor   ---   */

	public TimerScreen(Counter applet,
	                   ImageBox imageBox,MessageManager message)
	{
		this.applet  =applet;
		this.main    =applet;
		this.imageBox=imageBox;
		this.message =message;
		
		addOffscreenListener(this);
		
		calculateUnit();
		reset();
	}

	/*   ---      ---   */

	private void calculateUnit()
	{
/*
		long t;
	
		t=System.currentTimeMillis();
		while (t==System.currentTimeMillis()) Thread.yield();
		unit=1000/(((int)(System.currentTimeMillis()-t))*2);
*/
		unit=1;
	}

	public void reset()
	{
		stopTimer();
		
		time=10*unit;
		
		if (digit!=null) drawTimer();
	}

	public void offscreenChanged(OffscreenEvent event)
	{
		digit=new DigitPainter(getOffscreenGraphics());
		digit.setFont(imageBox.getImage("digit"),this);
		digit.setWidth(3);
		digit.setAlignment(DigitPainter.CENTER,DigitPainter.CENTER);
		
		drawTimer();
	}

	/*   ---   JEgAbv   ---   */

	public void startTimer()
	{
		if (mainLoop==null)
		{
			mainLoop=new Thread(this);
			mainLoop.start();
			stop=false;
		}
	}

	public void run()								// mainLoop
	{
		while (time>0)
		{
			try {Thread.sleep(1000/unit);}
			catch (InterruptedException e) {}
			
			if (stop) return;
			
			time--;
			drawTimer();
			
			if (random.nextDouble()<.2) message.drawGuts(time/unit);
		}
		
		main.stopGame();
	}

	public void stopTimer()
	{
		if (mainLoop!=null)
		{
			stop=true;
			try {mainLoop.join();}
			catch (InterruptedException e) {}
			mainLoop=null;
		}
	}

	/*   ---   `揈   ---   */

	public void drawTimer()
	{
		Dimension size;
	
		size=getSize();
		
		digit.drawDigit(time/unit,size.width/2,size.height/2);
		repaint();
	}
}
