/*   tHgw萔`  Ver 0.00   */
/*                                    */
/*                                    */
/*   by Atsushi             98/3/23   */


package game.awt;

import java.awt.*;
import java.awt.image.CropImageFilter;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageFilter;


public class DigitPainter extends Object
{
	/*   ---   萔   ---   */

	public final static double CENTER=-0.5;
	public final static double LEFT  =-1.0;
	public final static double RIGHT = 0.0;
	public final static double UP    =-1.0;
	public final static double DOWN  = 0.0;

	public final static int AUTO=-1;

	/*   ---   Field   ---   */

	private Graphics g;
	private Image image[];

	private Dimension imageSize;

	private double alignmentX,alignmentY;
	private int width;

	/*   ---   Constructor   ---   */

	public DigitPainter(Graphics g)
	{
		this.g    =g.create();
		this.image=new Image[11];
		
		alignmentX=RIGHT;
		alignmentY=DOWN;
		width     =AUTO;
	}

	/*   ---   tHgݒ   ---   */

	public void setFont(Image image,Component component)
	{
		MediaTracker tracker;
		ImageFilter filter;
	
		imageSize=new Dimension(image.getWidth(null)/11,image.getHeight(null));
		tracker=new MediaTracker(component);
		for (int i=0;i<=10;i++)
		{
			filter=new CropImageFilter(imageSize.width*i,0,
			                           imageSize.width,imageSize.height);
			this.image[i]=Toolkit.getDefaultToolkit().createImage(
			              new FilteredImageSource(image.getSource(),filter));
			tracker.addImage(this.image[i],0);
		}
		
		try {tracker.waitForAll();}
		catch (InterruptedException e) {}
	}

	/*   ---   `揈   ---   */

	public void drawDigit(String str,int x,int y)
	{
		int number;
		int bx,by;
	
		bx=x+(int)(imageSize.width *str.length()*alignmentX);
		by=y+(int)(imageSize.height             *alignmentY);
		for (int i=0;i<=str.length()-1;i++)
		{
			number=Character.digit(str.charAt(i),10);
			g.drawImage(image[1+number],bx+imageSize.width*i,by,null);
		}
	}

	public void drawDigit(int number,int x,int y)
	{
		int num,length;
		int bx,by;
	
		if (width==AUTO)
		{
			length=(int)(Math.floor(Math.log(number)/Math.log(10)))+1;
		}
		else
		{
			length=width;
		}
		num=number;
		bx=x+(int)(imageSize.width *length*alignmentX);
		by=y+(int)(imageSize.height       *alignmentY);
		for (int i=0;i<=length-1;i++)
		{
			g.drawImage(image[1+num%10],
			            bx+imageSize.width*(length-1-i),by,null);
			if (num> 0) num=num/10;
			if (num==0) num=-1;
		}
	}

	/*   ---      ---   */

	public void setAlignment(double x,double y)
	{
		alignmentX=x;
		alignmentY=y;
	}

	/*   ---      ---   */

	public void setWidth(int length)
	{
		width=length;
	}

	/*   ---   ̑傫   ---   */

	public Dimension getSize()
	{
		return imageSize;
	}
}
