/*   nCXRALO  Ver 0.20   */
/*                                    */
/*                                    */
/*   by Atsushi             98/3/19   */


package game.ranking;

import java.io.IOException;
import java.net.URL;
import java.text.ParseException;
import java.util.StringTokenizer;
import lib.util.Pile;
import lib.net.TextCGI;
import lib.net.TextCGILocal;


public class RankingClient extends Object
{
	/*   ---   Field   ---   */

	private URL host;

	/*   ---   Constructor   ---   */

	public RankingClient(URL host)
	{
		this.host=host;
	}

	/*   ---   wb_   ---   */

	public String getHeader() throws IOException,ParseException
	{
		TextCGI cgi;
	
		cgi=createTextCGI(new URL(host,"ranking-header.cgi"));
		cgi.connect();
		
		return cgi.post("");
	}

	/*   ---   o^   ---   */

	public RankingRecord put(double score,String name)
	                         throws IOException,ParseException
	{
		return put("score="+score+"&name="+name);
	}

	public RankingRecord put(double score,String name,String extension)
	                         throws IOException,ParseException
	{
		return put("score="+score+"&name="+name+"&extension="+extension);
	}

	private RankingRecord put(String args)
	                          throws IOException,ParseException
	{
		RankingRecord record;
		TextCGI cgi;
	
		cgi=createTextCGI(new URL(host,"ranking.cgi"));
		cgi.connect();
		
		record=RankingRecord.decode(cgi.post(args));
		
		return record;
	}

	/*   ---   ꗗ   ---   */

	public RankingRecord[] list() throws IOException,ParseException
	{
		return list("");
	}

	public RankingRecord[] list(int end) throws IOException,ParseException
	{
		return list("end="+end);
	}

	public RankingRecord[] list(int begin,int end)
	                            throws IOException,ParseException
	{
		return list("begin="+begin+"&end="+end);
	}

	private RankingRecord[] list(String args)
	                             throws IOException,ParseException
	{
		Pile record=new Pile(RankingRecord.class);
		TextCGI cgi;
		StringTokenizer tokenizer;
		String output;
	
		cgi=createTextCGI(new URL(host,"ranking-list.cgi"));
		cgi.connect();
		output=cgi.post(args);
		
		if (output.startsWith("no entry")) return new RankingRecord[0];
		
		tokenizer=new StringTokenizer(output,"\n\r");
		while (tokenizer.hasMoreTokens())
		{
			record.pileUp(RankingRecord.decode(tokenizer.nextToken()));
		}
		
		return (RankingRecord[])(record.get());
	}

	/*   ---   CGI\z   ---   */

	private TextCGI createTextCGI(URL url)
	{
		if (url.getProtocol().equals("file"))
		{
			return new TextCGILocal(url);
		}
		else
		{
			return new TextCGI(url);
		}
	}
}
