/*   nCXRALO  Ver 0.30   */
/*                                    */
/*                                    */
/*   by Atsushi             98/4/24   */


package game.ranking;

import java.io.*;
import java.text.DateFormat;
import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;
import java.util.StringTokenizer;


public class RankingRecord extends Object
{
	/*   ---   Field   ---   */

	private double score;
	private String name;
	private Calendar date;

	private String extension;

	/*   ---   Constructor   ---   */

	public RankingRecord(double score,String name)
	{
		this(score,name,null);
	}

	public RankingRecord(double score,String name,String extension)
	{
		this.score    =score;
		this.name     =name;
		this.extension=extension;
		
		date=Calendar.getInstance();
	}

	/*   ---      ---   */

	public static RankingRecord decode(String str) throws ParseException
	{
		RankingRecord record;
		StringTokenizer tokenizer;
		String name,date;
		double score;
		int x;
	
		try {
			tokenizer=new StringTokenizer(str.trim(),"\t");
			score=Double.valueOf(tokenizer.nextToken()).doubleValue();
			name =tokenizer.nextToken();
			date =tokenizer.nextToken()+" "+tokenizer.nextToken();
			if (tokenizer.hasMoreTokens())
			{
				record=new RankingRecord(score,name,tokenizer.nextToken());
			}
			else
			{
				record=new RankingRecord(score,name);
			}
			
			tokenizer=new StringTokenizer(date,"/ :");
			record.date.set(Calendar.YEAR,
			                Integer.parseInt(tokenizer.nextToken()));
			record.date.set(Calendar.MONTH,
			                Integer.parseInt(tokenizer.nextToken()));
			record.date.set(Calendar.DAY_OF_MONTH,
			                Integer.parseInt(tokenizer.nextToken()));
			record.date.set(Calendar.HOUR_OF_DAY,
			                Integer.parseInt(tokenizer.nextToken()));
			record.date.set(Calendar.MINUTE,
			                Integer.parseInt(tokenizer.nextToken()));
			record.date.set(Calendar.SECOND,
			                Integer.parseInt(tokenizer.nextToken()));
		}
		catch (Exception e)
		{
			throw new ParseException(str,0);
		}
		
		return record;
	}

	/*   ---   C   ---   */

	public double getScore()
	{
		return score;
	}

	public String getName()
	{
		return name;
	}

	public Calendar getDate()
	{
		return date;
	}

	public String getExtension()
	{
		return extension;
	}

	/*   ---      ---   */

	public String toString()
	{
		String str;
	
		str=Double.toString(score);
		str=str+" "+name;
		str=str+" "+DateFormat.getDateTimeInstance().format(date.getTime());
		if (extension!=null) str=str+" "+extension;
		return str;
	}
}
