/*   CGINNX([JfobOp)  Ver 0.10   */
/*                                                 */
/*                                                 */
/*   by Atsushi                          98/3/24   */


package lib.net;

import java.io.*;
import java.net.URL;
import java.net.Socket;
import lib.net.TextCGI;


public class TextCGILocal extends TextCGI
{
	/*   ---   Field   ---   */

	private URL address;

	private Socket socket;

	private PrintWriter writer;
	private BufferedReader reader;

	/*   ---   Constructor   ---   */

	public TextCGILocal(URL address)
	{
		super(address);
	
		this.address=address;
	}

	/*   ---   ڑ   ---   */

	public void connect() throws IOException
	{
		socket=new Socket("localhost",10379);
		
		try {
			writer=new PrintWriter(
			       new OutputStreamWriter(socket.getOutputStream()));
			reader=new BufferedReader(
			       new InputStreamReader(socket.getInputStream()));
		}
		catch (IOException e)
		{
			socket.close();
			throw e;
		}
	}

	/*   ---   Submit   ---   */

	public String post(String input) throws IOException
	{
		String output;
		String line;
	
		try {
			writer.println("post "+address.toExternalForm());
			writer.println(input);
			writer.println("@");
			writer.flush();
			
			output="";
			while (true)
			{
				line=reader.readLine();
				if (line==null) break;
				output=output+line+"\n";
			}
		}
		finally
		{
			socket.close();
		}
		return output;
	}

	public String get() throws IOException
	{
		String output;
		String line;
	
		try {
			writer.println("get "+address.toExternalForm());
			writer.println("@");
			writer.flush();
			
			output="";
			while (true)
			{
				line=reader.readLine();
				if (line==null) break;
				output=output+line+"\n";
			}
		}
		finally
		{
			socket.close();
		}
		return output;
	}
}
