/*   ςݏグNX  "Pile"  Ver 0.20   */
/*                                      */
/*                                      */
/*   by Atsushi                9/9/24   */


package lib.util;

import java.lang.reflect.Array;
import java.util.Vector;


public class Pile extends Vector
{
	/*   ---   Field   ---   */

	private Class type;

	/*   ---   Constructor   ---   */

	public Pile(Class type)
	{
		super();
		this.type=type;
	}

	/*   ---   ς   ---   */

	public synchronized void pileUp(Object item)
	{
		if (!type.isInstance(item))
			throw new IllegalArgumentException("Illegal Type : "+
			                                   item.getClass().getName());
		addElement(item);
	}

	public synchronized void unify()
	{
		int x;
	
		for (int i=0;i<=size()-1;i++)
		{
			x=indexOf(elementAt(i),i+1);
			if (x>=0) removeElementAt(x);
		}
		trimToSize();
	}

	public synchronized void clear()
	{
		removeAllElements();
	}

	/*   ---      ---   */

	public synchronized Object[] get()
	{
		Object obj[];
	
		obj=(Object[])(Array.newInstance(type,size()));
		copyInto(obj);
		return obj;
	}
}
