/*   摜\tpR|[lg  "Paper"  Ver 0.20   */
/*                                                     */
/*                                                     */
/*   by Atsushi                               9/10/6   */


package lib.awt;

import java.awt.*;


public class Paper extends Component
{
	/*   ---   Field   ---   */

	private Image image;
	private boolean scaling;

	/*   ---   Constructor   ---   */

	public Paper(Image image,boolean scaling)
	{
		this.image  =image;
		this.scaling=scaling;
		
		setBackground(Color.white);
		enableEvents(AWTEvent.COMPONENT_EVENT_MASK);
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
		enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);
		enableEvents(AWTEvent.FOCUS_EVENT_MASK);
		enableEvents(AWTEvent.KEY_EVENT_MASK);
	}

	public Paper(Image image)
	{
		this(image,false);
	}

	public Paper()
	{
		this(null);
	}

	/*   ---      ---   */

	public Image getImage()
	{
		return image;
	}

	public void setImage(Image image)
	{
		this.image=image;
		repaint();
	}

	public boolean isScaling()
	{
		return scaling;
	}

	public void setScaling(boolean state)
	{
		scaling=state;
		repaint();
	}

	public Dimension getPreferredSize()
	{
		if (image==null)
		{
			return getMinimumSize();
		}
		else
		{
			return new Dimension(image.getWidth(null),image.getHeight(null));
		}
	}

	/*   ---   `揈   ---   */

	public void paint(Graphics g)
	{
		Dimension size;
		int x,y,sx,sy;
	
		size=getSize();
		if (image==null)
		{
			g.clearRect(0,0,size.width,size.height);
		}
		else if (scaling)
		{
			g.drawImage(image,0,0,size.width,size.height,this);
		}
		else
		{
			sx=image.getWidth (this);
			sy=image.getHeight(this);
			x=(size.width -sx)/2;
			y=(size.height-sy)/2;
			if (y>0) g.clearRect( 0  , 0  ,sx, y);
			if (y<0) g.clearRect( 0  ,sy+y,sx,-y);
			if (x>0) g.clearRect( 0  , 0  , x,sy);
			if (x<0) g.clearRect(sx+x, 0  ,-x,sy);
			g.drawImage(image,x,y,this);
		}
	}

	/*   ---   Method  Override   ---   */

	protected String paramString()
	{
		String param;
	
		param=super.paramString();
		if (scaling) param+=",scaling";
		return param;
	}
}
